<?php
/**
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

define('_THISTHEME_', __DIR__);

/* Sprachdatei auswählen */
mxGetLangfile(__DIR__);

/* Theme stellt eigenes Adminmenü bereit */
define('GRAPHICADMIN', true);

/* definieren ob die Templates des Themes gecached werden koennen */
define('MX_THEME_CACHABLE', true);

/* Dateiname des templates */
define('MX_THIS_THEMEFILE', 'theme.html');

require(_THISTHEME_ . '/theme.colors.php');
require_once(_THISTHEME_ . '/theme.functions.php');

if (MX_IS_ADMIN && !defined('mxAdminFileLoaded')) {
    echo '<h1 class="error">Error: admintheme "' . basename(_THISTHEME_) . '" selected...</h1>';
}
$GLOBALS['TidyOutput']=0;

/* nur wenn theme.php normal verwendet wird, nicht für CSS */
if (!defined('DONT_INIT_THEME') || DONT_INIT_THEME == false) {
    /* zu alte pragmaMx-Version */
    if (version_compare(PMX_VERSION, '2.8', '<')) {
        die('<br />Sorry, theme "' . basename(_THISTHEME_) . '" requires pragmaMx version >= 2.8');
    }

    /* die themeEngine laden */
    include_once(PMX_SYSTEM_DIR . '/mx_themes.php');

    /* bei Bedarf den Dokumenttyp anpassen :) */
    if (!theme_check_xhtmldoctype()) {
        $GLOBALS['DOCTYPE'] = 5;
    }
}
	pmxHeader::add_jquery();
	pmxHeader::add_style(MX_THEME_DIR . '/style/adminlte.min.css');
	pmxHeader::add_style(MX_THEME_DIR . '/style/pragmamx.default.css');
    pmxHeader::add_style(MX_THEME_DIR . '/style/cssmenue.css');
	//pmxHeader::add_style(MX_THEME_DIR . '/style/fontawesome.css');
    pmxHeader::add_style(MX_THEME_DIR . '/style/all.css');
	pmxHeader::add_body_script(_THISTHEME_ ."/js/bootstrap/js/bootstrap.bundle.min.js");
	pmxHeader::add_body_script(_THISTHEME_ ."/js/adminlte.min.js");

?>